;***************************** NTC Routinen ********************************

;************************** mit ADC-Wert des NTC **************************
; Sub: Wartet ca. 20ms
; Parameter:	-
; Return:		-
; Scratch-Reg:	-
;***************************************************************************

tiny_temp_read:
		ldi		TEMP_0,(1<<REFS1) | (1<<MUX3) | (1<<MUX2) | (1<<MUX1) | (1<<MUX0)		; 1,1V Refs, ADC4
		out		ADMUX,TEMP_0

		ldi		TEMP_0,(1<<ADEN) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0)		; ADC ein, Prescale 64 -> 125kHz
		out		ADCSRA,TEMP_0

		ldi		TEMP_0,(1<<ADC3D)								; digital In-Buffer aus
		out		DIDR0,TEMP_0	 

		ldi		TEMP_0,3

tiny_temp_read_loop:
		sbi		ADCSRA,ADSC										; Start

tiny_temp_read_wait:
		sbic	ADCSRA,ADSC										; fertig?
		rjmp	tiny_temp_read_wait								; nein

		in		TEMP_L,ADCL
		in		TEMP_H,ADCH

		dec		TEMP_0
		brne	tiny_temp_read_loop

		cbi		ADCSRA,ADEN										; ADC aus
		
		ret
