
; ATtiny85

; 01.03.2009 M'Soft Berlin

.equ	VER		= '0'
.equ	REV		= '1'

.include "tn85def.inc"

.include "Definitionen.inc"

;****************************** Verktor-Liste ************************

.CSEG
       rjmp    Reset

.ORG	PCI0addr
		rjmp	irq_pin_change					; Sleep beenden
			 
;****************************** Programm-Beginn **********************

;*********************************************************************
;  Initialisierungsroutine
;*********************************************************************

.ORG	INT_VECTORS_SIZE

; Hardware initialisieren

Reset:
		ldi     TEMP_0,low(RAMEND)          		; Stack an das interne Ram-Ende
        out     SPL,TEMP_0
		ldi     TEMP_0,high(RAMEND)
        out     SPH,TEMP_0

; Port B *************************************************************

		ser		TEMP_0		
        out     PORTB,TEMP_0 
		ldi		TEMP_0,~(1<<RFM02_IRQ)				; nIRQ Eingang 
		out     DDRB,TEMP_0

; PIN CHANGE *********************************************************

		ldi		TEMP_0,(1<<RFM02_IRQ)
		out		PCMSK,TEMP_0

		ldi		TEMP_0,(1<<SE) | (1<<SM1)			; Sleep Enable, PowerDown
		out		MCUCR,TEMP_0

;*********************************************************************				 

; Software initialisieren
		ldi		TEMP_0,200							; 400ms

init_wait_loop:
		rcall	wait_20ms
		dec		TEMP_0
		brne	init_wait_loop

		rcall	rfm02_init

		rcall	init_text									; Versionstext in DATA_BUF kopieren

		rcall	rfm02_check_spannung						; testet Batteriespannung und schreibt Wert in DATA_BUF						

		rcall	checksum									; Checksumme berechnen

		rcall	rfm02_send_data								; und senden

		rcall	init_data_buf								; setzt DATA_BUF erstmal auf 0x55 -> kein Sensor

		sei

;*********************************************************************
;  Main-Loop
;*********************************************************************

main:		
		rcall	tiny_temp_read
		rcall	convert_temp
					
		rcall	checksum

		rcall	rfm02_send_data
		rcall	rfm02_send_data

		ldi		TEMP_0,(1<<PCIF)					; evtl. noch anstehenden IRQ lschen
		out		GIFR,TEMP_0

		ldi		TEMP_0,(1<<PCIE)					; Pin-Change-IRQ an
		out		GIMSK,TEMP_0

		sleep

		rjmp	main

;*********************************************************************				 

irq_pin_change:
		out		GIMSK,NULL						; Pin-Change-IRQ aus

		reti

;*********************************************************************				 

.include "Subroutinen.inc"
.include "TINY_TEMP.inc"
.include "RFM02.inc"

text:
	.db	(SENSOR | 0x30), ~(SENSOR | 0x30), "Ver.",VER,".",REV," Ub:2,2V",0

